require 'sugar'

express = require 'express'

path = require 'path'
form = require 'connect-form'
helpers = require './helpers'


module.exports =
  start: (port) ->
    app.listen(port)
  
  init: (app_dir, conf) ->
    global.app = express.createServer(form({ keepExtensions: true }))
    
    # Settings

    app.conf = conf
    
    # Database

    uri = process.env["MONGOHQ_URL"]
    unless uri      
      uri = "mongodb://localhost/#{ conf.database_name }"

    console.log "Use database: #{uri}"

    app.mongoose = require 'mongoose'
    app.db = app.mongoose.connect uri

    # Application

    app.configure ->
      app.use express.static(path.join app_dir, 'public')
      app.use express.bodyParser()
      app.use express.cookieParser()
      app.use express.session({ secret: "this_is_super_secret_string", cookie: { maxAge: 86400000 } })
      app.use app.router
      app.use express.errorHandler({ showStack: true, dumpExceptions: true })

    app.get '/*', (req, res, next) ->
      req.conf = app.conf;
      req.helpers = helpers
      next()
    
    if conf.redirect_www
      app.get '/*', (req, res, next) ->
        if req.headers.host.match(/^www\./)
          res.redirect "http://#{req.headers.host.replace(/^www\./, '')}#{req.url}", 301
        else
          next()

    # This module overrides default express render method
    require './templates'
    require './blog'
    
